/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package nexus.core;

import csbs2.ui.Login;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.net.URLEncoder;
import java.net.UnknownHostException;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;

/**
 *
 * @author Luke
 */
public class HabboLogin {

    private String cookie = "";
    private String hotel = "";
    private Login logi = null;
    protected PacketHandler handler = null;

    public void setPacketHandler(PacketHandler h) {
        handler = h;
    }

    public HabboLogin(String hotel) {
        this.hotel = hotel;
    }

    public void setLogin(Login l) { /* CSBS2 ONLY FUNCTION */
        logi = l;
    }

    public void setStatus(String status, int perc) { /* CSBS2 ONLY FUNCTION */
        if (logi != null) {
            logi.jProgressBar1.setString(status);
            logi.jProgressBar1.setValue(perc);
        }
    }

    public HabboConnection login(String username, String password) throws UnknownHostException, IOException {
        Socket s = new Socket(hotel, 80); // connect to habbo
        InputStream in = s.getInputStream();
        OutputStream out = s.getOutputStream();

        out.write("GET / HTTP/1.1\r\n".getBytes());
        out.write(("Host: " + (hotel.startsWith("www") ? hotel : ("www." + hotel)) + "\r\n").getBytes()); // yay for ternary operators
        out.write("User-Agent: Mozilla/5.0 (LibConnect; rv:1.0) Gecko/20101203 LibConnect/1.0\r\n".getBytes());
        out.write("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n".getBytes());
        out.write("Connection: close\r\n\r\n".getBytes());
        out.flush(); // write request
        int r = 0;
        String response = "";
        while ((r = in.read()) != -1) { // read response
            response += (char) r;
        }

        cookie = response.split("Set-Cookie: ")[1].split("\r\n")[0]; // save the cookie, it is needed for login.
        setStatus("Initiating SSL connection...", 10);
        s.close();

        SSLSocketFactory factory = (SSLSocketFactory) SSLSocketFactory.getDefault();
        SSLSocket socket = (SSLSocket) factory.createSocket(hotel, 443); // create a new SSL socket
        // enable all the suites
        String[] supported = socket.getSupportedCipherSuites();
        socket.setEnabledCipherSuites(supported);
        out = socket.getOutputStream();
        in = socket.getInputStream();

        out.write(("POST https://" + (hotel.startsWith("www") ? hotel : ("www." + hotel)) + "/account/submit HTTP/1.1\r\n").getBytes());
        out.write(("Host: " + (hotel.startsWith("www") ? hotel : ("www." + hotel)) + "\r\n").getBytes());
        out.write("User-Agent: Mozilla/5.0 (LibConnect; rv:1.0) Gecko/20101203 LibConnect/1.0\r\n".getBytes());
        out.write("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n".getBytes());
        out.write("Connection: close\r\n".getBytes());
        out.write(("Cookie: " + cookie + "\r\nContent-Type: application/x-www-form-urlencoded\r\n").getBytes());
        out.write(("Content-Length: " + String.valueOf(("credentials.username=" + URLEncoder.encode(username) + "&" + "credentials.password=" + password).length()) + "\r\n").getBytes());
        out.write(("\r\ncredentials.username=" + URLEncoder.encode(username) + "&" + "credentials.password=" + password + "\r\n").getBytes()); //damn deprecated methods
        out.flush();

        response = "";
        while ((r = in.read()) != -1) { // read response
            response += (char) r;
        }
        socket.close();
        boolean first = true;
        for (String st : response.split("Set-Cookie: ")) { // update cookie
            if (!first) {
                cookie += ";" + st.split("\r\n")[0];
            } else {
                first = false;
            }
        }
        if (!response.contains("If you are not automatically redirected")) {

            return null;
        }
        s = new Socket(hotel, 80); // connect to habbo
        in = s.getInputStream();
        out = s.getOutputStream();

        setStatus("Loading redirect URL...",20);
        out.write(("GET " + response.split("If you are not automatically redirected, please <a href=\"")[1].split("\"")[0] + " HTTP/1.1\r\n").getBytes());
        out.write(("Host: " + (hotel.startsWith("www") ? hotel : ("www." + hotel)) + "\r\n").getBytes());
        out.write("User-Agent: Mozilla/5.0 (LibConnect; rv:1.0) Gecko/20101203 LibConnect/1.0\r\n".getBytes());
        out.write("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n".getBytes());
        out.write("Connection: close\r\n".getBytes());
        out.write(("Cookie: " + cookie + "\r\n\r\n").getBytes());
        out.flush(); // write request
        r = 0;
        response = "";
//        while ((r = in.read()) != -1) { // read response
//            response += (char) r;
//        }
        s.close();
        s = new Socket(hotel, 80); // connect to habbo
        in = s.getInputStream();
        out = s.getOutputStream();
        setStatus("Loading /me...",30);
        out.write(("GET /me HTTP/1.1\r\n").getBytes());
        out.write(("Host: " + (hotel.startsWith("www") ? hotel : ("www." + hotel)) + "\r\n").getBytes());
        out.write("User-Agent: Mozilla/5.0 (LibConnect; rv:1.0) Gecko/20101203 LibConnect/1.0\r\n".getBytes());
        out.write("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n".getBytes());
        out.write("Connection: close\r\n".getBytes());
        out.write(("Cookie: " + cookie + "\r\n\r\n").getBytes());
        out.flush(); // write request
        r = 0;
        response = "";
//        while ((r = in.read()) != -1) { // read response
//            response += (char) r;
//        }
//        in.read();
        s.close();
        s = new Socket(hotel, 80); // connect to habbo
        in = s.getInputStream();
        out = s.getOutputStream();
        setStatus("Loading /client...",95);
        out.write(("GET /client HTTP/1.1\r\n").getBytes());
        out.write(("Host: " + (hotel.startsWith("www") ? hotel : ("www." + hotel)) + "\r\n").getBytes());
        out.write("User-Agent: Mozilla/5.0 (LibConnect; rv:1.0) Gecko/20101203 LibConnect/1.0\r\n".getBytes());
        out.write("Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8\r\n".getBytes());
        out.write("Connection: close\r\n".getBytes());
        out.write(("Cookie: " + cookie + "\r\n\r\n").getBytes());
        out.flush(); // write request
        r = 0;
        response = "";
        while ((r = in.read()) != -1) { // read response
            response += (char) r;
        }
        setStatus("Loading /client...",100);
        return new HabboConnection(this, response, hotel, cookie);
    }
}
