/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package nexus.core;

import java.io.ByteArrayInputStream;

/**
 *
 * @author Luke
 */
public class HabboPacket extends ByteArrayInputStream {
    
    public byte[] dat;
    String header;
    
    public HabboPacket(byte[] data){
        super(data);
        dat = data;
        header = new String(data, 0, 2);
        skip(2);
    }
    
    public String getHeader(){
        return header;
    }
    
    public byte[] getBytes(){
        return dat;
    }
    
    public String toBinaryString(){
        StringBuilder builder = new StringBuilder();
        for(byte b : dat){
            char c = (char) b;
            if(c >= 0x10 && c <= 0x80 &&  c != '[' &&  c != ']') {
                builder.append(c);
            } else {
                builder.append("[");
                builder.append(Integer.toHexString(c));
                builder.append("]");
            }
        }
        return builder.toString();
    }
    
    public String readString(){
        StringBuilder b = new StringBuilder();
        int r;
        while((r = read()) > -1){
            if(r == 2) break;
            b.append((char) r);
        }
        return b.toString();
    }
    
    public int readVL64(int len){
        StringBuilder b = new StringBuilder();
        int r;
        while((r = read()) > -1){
            if(len <= 0) break;
            b.append((char) r);
            len--;
        }
        return VL64.decode(b.toString().toCharArray());
    }
    
    public int readVL64(){
        return VL64.decode(readString().toCharArray());
    }

}
